#ifndef QUEUE_H
#define QUEUE_H

#include "stdbool.h"

typedef struct queue queue;

/* create a new empty queue (FIFO) */
queue *new_queue();

/* add element to front of the queue */
bool enqueue (queue *q, void *elem);

/* take element from back of queue */
void *dequeue (queue *q);

bool is_empty (queue *q);

/* must be empty to free */
bool free_queue(queue *q);

#endif
